import express from 'express'
import Korisnik from '../models/korisnik';
import Proizvod from '../models/proizvod'

export class ProizvodController{
    dohvatiSveProizvodeKojihImaNaStanju=(req: express.Request, res: express.Response)=>{
        Proizvod.find({'kolicina':{$gt:0}},(err, proizvodi)=>{
            if(err) console.log(err);
            else res.json(proizvodi);
        })
    }

    dohvatiSveProizvode=(req: express.Request, res: express.Response)=>{
        Proizvod.find({},(err, proizvodi)=>{
            if(err) console.log(err);
            else res.json(proizvodi);
        })
    }

    dodajProizvod = (req: express.Request, res: express.Response)=>{
        let naziv = req.body.naziv;

        Proizvod.updateOne({'naziv': naziv}, {$inc: {'kolicina':1}}, (err, resp)=>{
            if(err) console.log(err)
            else res.json({poruka:'ok'})
        });
        
    }

    ukloniProizvod = (req: express.Request, res: express.Response)=>{
        let naziv = req.body.naziv;

        Proizvod.updateOne({'naziv': naziv},{$inc: {'kolicina':-1}}, (err, resp)=>{
            if(err) console.log(err)
            else res.json({poruka:'ok'})
        });
        
    }

    kupiProizvod = (req: express.Request, res: express.Response)=>{
        let naziv = req.body.naziv;
        let kor_ime = req.body.kor_ime;

        //console.log(naziv);
        //console.log(kor_ime);

        Proizvod.updateOne({'naziv': naziv}, {$inc: {'kolicina':-1}}, (err, resp)=>{
            if(err) console.log(err)
        });
        Korisnik.findOne({'kor_ime': kor_ime, 'proizvodi.naziv': naziv}, (err, korisnikJeKupovaoProizvod)=>{
            if(err) console.log(err);
            else{
                if(korisnikJeKupovaoProizvod){
                    //updejt kolicina
                    Korisnik.updateOne(
                        {'kor_ime': kor_ime, 'proizvodi.naziv': naziv},
                        {$inc: {'proizvodi.$.kolicina': 1}}, (err, resp)=>{
                            if(err) console.log(err)
                            else res.json({poruka: 'ok'});
                        });
                }
                else{
                    //dodaj novi objekat
                    let kupovina={
                        naziv: naziv,
                        kolicina: 1
                    }
                    Korisnik.updateOne({'kor_ime': kor_ime}, 
                    {$push: {"proizvodi": kupovina}}, (err, resp)=>{
                        if(err) console.log(err)
                        else res.json({poruka: 'ok'});
                    });
                }
                
            }
        })
    }

    oceniProizvod = (req: express.Request, res: express.Response)=>{
        let naziv = req.body.naziv;
        let ocena = req.body.ocena;

        let ocenaObj= {
            ocena: ocena
        }

        Proizvod.updateOne({'naziv': naziv}, 
        {$push: {'ocene': ocenaObj}}, (err, resp)=>{
            if(err) console.log(err)
            else res.json({poruka: 'ok'});
        });
    }
}